; Eastweed - EAsy STatic WEb EDitor
; Copyright (C) 2006, 2007, 2008, 2009 Gianni Ciolli <gc@inatna.it> 
; file deploy.scm, version 0.7beta, date 2009-02-26
;
; Based on existing code (C) 2001, 2004 by Marco Maggesi
; <maggesi@math.unifi.it> and Gianni Ciolli <ciolli@math.unifi.it>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

;; deploy.scm - this script deploys eastweed from an installation
;; directory into a website main directory.  Essentially: (1) it
;; checkes that the environment variable EASTWEED_INSTALLATION is
;; defined and carries a valid value, (2) loads Eastweed kernel and
;; (3) invokes the Eastweed deploy module.

(let ((dir (getenv "EASTWEED_INSTALLATION"))
      (filename "main.scm"))
  (if (not dir)
      (error
"the environment variable EASTWEED_INSTALLATION is not defined")
      (let ((f (string-append
		dir
		(if (equal? #\/
			    (string-ref dir (- (string-length dir) 1)))
		    ""
		    "/")
		filename)))
	(if (not (file-exists? f))
	    (error 
"the directory pointed by the environment variable EASTWEED_INSTALLATION
is not a valid installation of Eastweed version 0.7 or greater")
	    (begin
	      (load f)
	      (eastweed 'require 'deploy))))))
