; Eastweed - EAsy STatic WEb EDitor
; Copyright (C) 2006, 2007, 2008, 2009 Gianni Ciolli <gc@inatna.it> 
; file main.scm, version 0.7beta, date 2009-02-26
;
; based on existing code (C) 2001, 2004 by Marco Maggesi
; <maggesi@math.unifi.it> and Gianni Ciolli <ciolli@math.unifi.it>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define eastweed-installation
  (let ((dir (getenv "EASTWEED_INSTALLATION")))
    (string-append dir
		   (if (equal? #\/
			       (string-ref dir (- (string-length dir) 1)))
		       ""
		       "/"))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define eastweed
  (let ((modules '()))
    (lambda args
      (if 
       (null? args)
       #f
       (case (car args)
	 ;;
	 ((require)
	  (map (lambda (y)
		 (when (not (member y modules))
		       (load (string-append
			      eastweed-installation
			      "module-"
			      (symbol->string y)
			      ".scm"))
		       (set! modules (cons y modules))))
	       (cdr args)))
	 ;;
	 ((get)
	  (eastweed-parameter 'get (cadr args)))
	 ;;
	 ((set!)
	  (eastweed-parameter 'set! (cadr args) (caddr args)))
	 ;;
	 ((assert)
	  (let ((x (eastweed 'get (cadr args))))
	    (unless x
		    (errmsg "required parameter not defined: " (cadr args)))))
	 ;;
	 ((update)
	  (eastweed 'require 'update)
	  (update-recent-files))
	 ;;
	 ((update-all)
	  (eastweed 'require 'update)
	  (update-all-files))
	 ;;
	 (else
	  (errmsg "eastweed: unknown action " (car args))))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(eastweed 'require 'config)
