; Eastweed - EAsy STatic WEb EDitor
; Copyright (C) 2006, 2007, 2008, 2009 Gianni Ciolli <gc@inatna.it> 
; file module-parameters.scm, version 0.7beta, date 2009-02-26
;
; Based on existing code (C) 2001, 2004 by Marco Maggesi
; <maggesi@math.unifi.it> and Gianni Ciolli <ciolli@math.unifi.it>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

;; module-parameters.scm - this is the Eastweed parameter management module.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (set-assoc-then-replace obj value l)
  ; l should be a list of pairs. This procedure computes a list of
  ; pairs where the pair having car equal? to obj is replaced by the
  ; pair (cons obj value) . The order of pairs is not kept (whence the
  ; prefix "set-").
  ; Rationale: a similar thing can be done with mutable pairs, but
  ; from R6RS they are "emarginated", so this immutable solution which
  ; tastes better.
  (let loop ((l l)
	     (a '()))
    (cond
     ((null? l)
      (reverse a))
     ((equal? (caar l) obj)
      (append a
       (cons (cons obj value) (cdr l))))
     (else
      (loop (cdr l)
	    (cons (car l) a))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define eastweed-parameter
  (let ((parameter-list '()))
    (lambda args
      (if 
       (null? args)
       #f
       (case (car args)
	 ;;
	 ((get)
	  (if (not (= (length args) 2))
	      (errmsg "eastweed-parameter 'get: syntax error: " args)
	      (let ((p (assoc (cadr args) parameter-list)))
		(if p (cdr p) 
		    (errmsg "can't get unset parameter " (cadr args))))))
	 ((set!)
	  (if (not (= (length args) 3))
	      (errmsg "eastweed-parameter 'set!: syntax error: " args)
	      (let ((p (assoc (cadr args) parameter-list)))
		(if p
		    (set! parameter-list
			  (set-assoc-then-replace 
			   (cadr args)
			   (caddr args)
			   parameter-list))
		    (set! parameter-list
			  (cons
			   (cons (cadr args) (caddr args))
			   parameter-list)))))))))))
